from src.models.abstract_reference import abstract_reference
from src.convert.basic_converter import basic_converter
from src.convert.converter import converter


class model_converter(converter):
    @staticmethod
    def convert(obj):
        from src.convert.converter_factory import converter_factory

        properties = {}
        for name in dir(obj.__class__):
            if name == "error":
                continue
            attr = getattr(obj.__class__, name)
            if isinstance(attr, property):
                v = attr.fget(obj)
                if issubclass(v.__class__, abstract_reference):
                    properties[name] = converter_factory.convert(v)
                else:
                    properties[name] = converter_factory.convert(v)
        return properties
