from src.errors.argument_exception import argument_exception
from src.logic.process_turn import process_turn
from src.validation.validator import validator
from src.storage.storage import storage


class process_factory:
    __smap = dict()

    def __init__(self):
        self.__vtor = validator()
        self.__build__()

    def __build__(self):
        self.__smap[storage.process_turn_key()] = process_turn()

    def create(self, format, strg):
        """Создать обработчик, соответствующий формату"""
        self.__vtor.check_type(format, str)
        self.__vtor.check_type(strg, storage)

        if format not in self.__smap.keys():
            raise argument_exception(
                f"Несуществующий формат ({format} not in {str(self.__smap)})"
            )

        return self.__smap[format]
