from src.models.measurement_unit_model import measurement_unit_model
from src.models.nomenclature_model import nomenclature_model
from src.models.warehouse_model import warehouse_model
from src.validation.validator import validator
from src.models.abstract_reference import abstract_reference


class storage_turn_model(abstract_reference):
    def __init__(self, name, warehouse, turn, nomenclature, measurement_unit):
        self.__vtor = validator()

        self.warehouse = warehouse
        self.turn = turn
        self.nomenclature = nomenclature
        self.measurement_unit = measurement_unit

        super().__init__(name)

    __warehouse = None

    @property
    def warehouse(self):
        """Склад"""
        return self.__warehouse

    @warehouse.setter
    def warehouse(self, value):
        """Склад"""
        self.__vtor.check_type(value, warehouse_model)
        self.__warehouse = value

    __turn = 0

    @property
    def turn(self):
        """Оборот"""
        return self.__turn

    @turn.setter
    def turn(self, value):
        """Оборот"""
        self.__vtor.check_number(value)
        self.__turn = value

    __nomenclature = None

    @property
    def nomenclature(self):
        """Номенклатура"""
        return self.__nomenclature

    @nomenclature.setter
    def nomenclature(self, value):
        """Номенклатура"""
        self.__vtor.check_type(value, nomenclature_model)
        self.__nomenclature = value

    __measurement_unit = None

    @property
    def measurement_unit(self):
        """Единица измерения"""
        return self.__measurement_unit

    @measurement_unit.setter
    def measurement_unit(self, value):
        """Единица измерения"""
        self.__vtor.check_type(value, measurement_unit_model)
        self.__measurement_unit = value
