from src.models.abstract_reference import abstract_reference
from src.validation.validator import validator


class warehouse_model(abstract_reference):
    # Адрес
    __address = ""

    def __init__(self, name=None):
        self.__vtor = validator()
        super().__init__(name)

    def create(name, address):
        obj = warehouse_model(name)
        obj.address = address
        return obj

    @property
    def address(self):
        """Адрес склада"""
        return self.__address

    @address.setter
    def address(self, value):
        """Адрес склада"""
        self.__vtor.check_type(value, str)
        self.__vtor.check_length_greater(value, 0)

        self.__address = value
