from datetime import datetime
from src.models.transaction_model import transaction_model
from src.validation.validator import validator


class storage_prototype:
    __data = []

    def __init__(self, data):
        self.__vtor = validator()
        self.__vtor.check_type(data, list)
        self.__data = data

    def filter_dt(self, from_dt: datetime, to_dt: datetime):
        """Отфильтровать по временному промежутку"""
        self.__vtor.check_type(from_dt, datetime)
        self.__vtor.check_type(to_dt, datetime)
        result = []
        for item in self.data:
            if item.time_span > from_dt and item.time_span <= to_dt:
                result.append(item)

        return storage_prototype(result)

    def filter_nom(self, filter_model):
        """Отфильтровать по номенклатуре"""
        result = []
        for item in self.data:
            if item.nomenclature.name != filter_model.name:
                continue
            result.append(item)
        return storage_prototype(result)

    def filter_recipe(self, recipe):
        """Отфильтровать по рецепту"""
        recipe_nomens = set([row.nomenclature.name for row in recipe.ingredients])
        result = []
        for item in self.data:
            if item.nomenclature.name not in recipe_nomens:
                continue
            result.append(item)
        return storage_prototype(result)

    @property
    def data(self) -> list:
        return self.__data
