import os
import unittest
from src.logic.process_factory import process_factory
from src.logic.start_factory import start_factory
from src.export.strategies.json_export import json_export
from src.models.recipe_model import recipe_model
from src.models.nomenclature_group_model import nomenclature_group_model
from src.models.nomenclature_model import nomenclature_model
from src.models.ingredient_model import ingredient_model
from src.export.strategies.csv_export import csv_export
from src.export.exporter import exporter
from src.models.measurement_unit_model import measurement_unit_model
from src.settings.settings import settings
from src.settings.settings_manager import settings_manager
from src.storage.storage import storage


class test_processes(unittest.TestCase):
    #
    # Проверка создания и записи транзакций
    #
    def test_create_transactions(self):
        """Проверить создание по транзакциям"""
        stor = storage()
        setman = settings_manager()
        setman.open(f"{os.path.dirname(__file__) + '/..'}/config/settings.json")
        st = setman.settings

        result = start_factory(st, stor).create_transactions()

        assert len(stor.data[stor.transaction_key()]) > 0

    def test_create_process(self):
        """Проверить создание по оборотам"""
        stor = storage()
        setman = settings_manager()
        setman.open(f"{os.path.dirname(__file__) + '/..'}/config/settings.json")
        st = setman.settings

        ts = start_factory(st, stor).create_transactions()

        ps = process_factory().create(stor.process_turn_key(), stor)
        res = ps.create(stor.data[stor.process_turn_key()])

        assert res is not None
